<template>
  <article
    class="relative"
    :class="dragging ? 'user-select-none bg-slate-50' : ''"
  >
    <Transition
      appear
      name="fade"
    >
      <div v-if="!dragging">
        <slot />
      </div>
    </Transition>

    <DropArea
      v-if="dropAreaShown"
      class="absolute -top-7 left-0 h-4 w-full sm:-left-7 sm:top-0 sm:h-full sm:w-4"
      @drop="moveTask({ type: 'after', taskId: $event as string })"
    />
    <DropArea
      v-if="dropAreaShown"
      class="absolute -bottom-7 left-0 h-4 w-full sm:-right-7 sm:bottom-0 sm:left-auto sm:h-full sm:w-4"
      @drop="moveTask({ type: 'before', taskId: $event as string })"
    />
  </article>
</template>

<script setup lang="ts">
import { useTasksStore } from '~/stores/tasks';
import { DropArea } from '~entities/dragAndDrop';
import { ITask, type DropTaskEvent } from '~entities/tasks';

const props = defineProps<{
  list: ITask;
  dragging: boolean;
}>();
defineEmits<{
  (e: 'drop', id: DropTaskEvent): void;
}>();
const store = useTasksStore();
const dropAreaShown = computed(() => !props.dragging && store.draggingTask);

const { id, parent, order } = toRefs(props.list);
const moveTask = ({ type, taskId }: DropTaskEvent) => {
  if (type === 'inside') {
    store.moveTask(taskId, id?.value);
  } else if (type === 'before') {
    store.moveTask(taskId, parent?.value, order.value - 0.5);
  } else if (type === 'after') {
    store.moveTask(taskId, parent?.value, order.value + 0.5);
  }
};
</script>
